tabloc = {
	locked : {},
	isLocked : function(tabId) {
		return tabloc.locked["locked_" + tabId];
	},
	setLocked : function(tabId, value) {
		if(value){
			tabloc.locked["locked_" + tabId] = value;
		}else{
			delete tabloc.locked["locked_" + tabId];
		}
	},
	lockTab : function(tabId) {
		var request = tabloc.getOptions();
		request.command = "lockTab";
		chrome.tabs.sendRequest(tabId, request, function(response){
			if(response.result == "ok"){
				tabloc.setLocked(tabId, true);
				chrome.browserAction.setIcon({
					path: (request.fg_foreground ? "locked2.png" : "locked.png"),
					tabId: tabId
				});
			}
		});
	},
	unlockTab : function(tabId) {
		chrome.tabs.sendRequest(tabId, {command: "unlockTab"}, function(response){
			if(response.result == "ok"){
				tabloc.setLocked(tabId, false);
				chrome.browserAction.setIcon({
					path: "tabloc.png",
					tabId: tabId
				});
			}
		});
	},
	getOptions : function() {
		return {
			fg_foreground: tabloc_options.get("fg_foreground"),
			ex_inpagelink: tabloc_options.get("ex_inpagelink"),
			ex_javascript: tabloc_options.get("ex_javascript"),
			ex_formsubmit: tabloc_options.get("ex_formsubmit"),
		};
	}
};

chrome.browserAction.onClicked.addListener(function(tab){
	if(! tabloc.isLocked(tab.id)){
		tabloc.lockTab(tab.id);
	}else{
		tabloc.unlockTab(tab.id);
	}
});

chrome.tabs.onUpdated.addListener(function(tabId, changeInfo, tab) {
	if(changeInfo.status == "loading" || tabloc.isLocked(tabId)){
		return;
	}
	var url = tab.url;
	var arr = tabloc_options.get("auto_url").split("\n");
	for(var i=0; i<arr.length; i++){
		if(url.match("^" + arr[i] + "$")){
			tabloc.lockTab(tabId);
			return;
		}
	}
});

chrome.extension.onRequest.addListener(
	function(request, sender, sendResponse) {
		if (request.command == "createTab") {
			if(tabloc_options.get("pos_relative")){
				chrome.tabs.getSelected(null, function(tab){
					chrome.tabs.create({
						url: request.url,
						selected: request.selected,
						index: tab.index + 1
					});
				});
			}else{
				chrome.tabs.create({
					url: request.url,
					selected: request.selected
				});
			}
			sendResponse({result: "ok"});
		}else{
			sendResponse({});
		}
	}
);
